using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Transactions;
using TheRM;

namespace RMUser
{
  class Program
  {
    static void Main(string[] args)
    {
      YourRMInTSC();
      //YourRMInTSCWithRollBack();
      //TwoInstancesOfYourRM();
      //YourRMWithOtherRM(); // Remember to setup DB before running this one.
    }

    static void YourRMInTSC()
    {
      var vrm = new VolatileRM("RM1");
      Console.WriteLine("Member Value:" + vrm.MemberValue);

      using (var tsc = new TransactionScope())
      {
        vrm.MemberValue = 3;
        tsc.Complete();
      }

      Console.WriteLine("Member Value:" + vrm.MemberValue);
      Console.ReadKey();
    }

    static void YourRMInTSCWithRollBack()
    {
      var vrm = new VolatileRM("RM1");
      Console.WriteLine("Member Value:" + vrm.MemberValue);

      using (var tsc = new TransactionScope())
      {
        vrm.MemberValue = 3;
        // tsc.Complete(); // <-- Removed!!!
      }

      Console.WriteLine("Member Value:" + vrm.MemberValue);
      Console.ReadKey();
    }

    static void TwoInstancesOfYourRM()
    {
      var vrm = new VolatileRM("RM1");
      var vrm2 = new VolatileRM("RM2");

      Console.WriteLine("Member Value:" + vrm.MemberValue);
      Console.WriteLine("Member Value:" + vrm2.MemberValue);

      using (var tsc = new TransactionScope())
      {
        vrm.MemberValue = 3;
        vrm2.MemberValue = 5;
        tsc.Complete();
      }

      Console.WriteLine("Member Value:" + vrm.MemberValue);
      Console.WriteLine("Member Value:" + vrm2.MemberValue);
      Console.ReadKey();
    }

    static void YourRMWithOtherRM()
    {
      string connStr = "Data Source=(local);Initial Catalog=Test1;Integrated Security=SSPI;";
      string cmdText = "Update FromTable Set Amount = Amount - 50";

      var vrm = new VolatileRM("RM1");
      Console.WriteLine("Member Value:" + vrm.MemberValue);

      using (var tsc = new TransactionScope())
      {
        using (var conn1 = new SqlConnection(connStr))
        {
          SqlCommand cmd1 = conn1.CreateCommand();
          cmd1.CommandText = cmdText;
          conn1.Open();
          cmd1.ExecuteNonQuery();
        }

        vrm.MemberValue = 3;

        tsc.Complete();
      }

      Console.WriteLine("Member Value:" + vrm.MemberValue);
      Console.ReadKey();
    }
  }
}
